### Virtual Method

# Gio PollableOutputStream writev_nonblocking

since: 2.60

#### Declaration

    GPollableReturn
    writev_nonblocking (
      GPollableOutputStream* stream,
      const GOutputVector* vectors,
      gsize n_vectors,
      gsize* bytes_written,
      GError** error
    )

#### Description

Attempts to write the bytes contained in the `n_vectors` `vectors` to `stream`, as with g_output_stream_writev(). If `stream` is not currently writable, this will immediately return %`G_POLLABLE_RETURN_WOULD_BLOCK`, and you can use `g_pollable_output_stream_create_source()` to create a `GSource` that will be triggered when `stream` is writable. `error` will not be set in that case.

Note that since this method never blocks, you cannot actually use `cancellable` to cancel it. However, it will return an error if `cancellable` has already been cancelled when you call, which may happen if you call this method after a source triggers due to having been cancelled.

Also note that if `G_POLLABLE_RETURN_WOULD_BLOCK` is returned some underlying transports like D/TLS require that you re-send the same `vectors` and `n_vectors` in the next write call.

The behaviour of this method is undefined if `g_pollable_output_stream_can_poll()` returns `FALSE` for `stream`.

Available since: 2.60

#### Parameters

`vectors`

  Type: An array of `GOutputVector`

  The buffer containing the `GOutputVectors` to write.

  The length of the array is specified in the `n_vectors` argument.
  The data is owned by the caller of the function.

`n_vectors`

  Type: `gsize`

  The number of vectors to write.

`bytes_written`

  Type: `gsize*`

  Location to store the number of bytes that were written to the stream.

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GPollableReturn`

%`G_POLLABLE_RETURN_OK` on success, `G_POLLABLE_RETURN_WOULD_BLOCK` if the stream is not currently writable (and `error` is not set), or `G_POLLABLE_RETURN_FAILED` if there was an error in which case `error` will be set.